#include "../lib/rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/bb/catchup.c 178 2004-05-05 06:09:03Z kc $")

#include "bb.h"

void catchup(char *parameter)
{
    int limit;
    char *limit_s;
    result_list *directory;
    directory_info *entry;
    int i, message, rid;

    limit_s = getword(parameter);
    if (*parameter) {
	fprintf(stderr, "unexpected input: '%s'\n", parameter);
	return;
    }
    if (!*limit_s) {
	return;
    } else {
	if (sscanf(limit_s, "%d", &limit) != 1) {
	    fprintf(stderr, "invalid limit '%s'\n", limit_s);
	    return;
	}
    }
    do_connect();
    if (!(directory = client_directory())) {
	fprintf(stderr, "%s\n", client_error);
	return;
    }
    for (i = 0; i < directory->count; i++) {
	entry = (directory_info *)directory->list[i];
	if (entry->priority < Cutoff_priority)
	    break;
	if (entry->new_messages > limit) {
	    if (!client_select(entry->name, &message, &rid))
		continue;
	    if (!client_setcurrent(-1 - limit)) {
		fprintf(cmdout, "Error setting message pointer in %s\n%s\n",
			entry->name, client_error);
		continue;
	    }
	    fprintf(cmdout, "Caught up in %s\n", entry->name);
	}
    }
    selectroom(Roomname);
}
