#include "../server/server.h"

summary_list *get_alt_summary(bb_rid room);
summary_list *get_dbm_summary(bb_rid room);

main(int argc, char *argv[])
{
    directory_entry room_info;
    bb_rid room;
    summary_list *summary;

    setlinebuf(stdout);
    setlinebuf(stderr);
    chdir(MESSAGEBASE);
    if (!database_init(FALSE)) {
	perror("database init failed");
	return 1;
    }
    for (room = 0; room <= Last_rid; room++) {
	if (!get_directory_entry(&room_info, room))
	    continue;
	if (!(summary = get_summary(room))) {
	    fprintf(stderr, "\nError retrieving summary for %s (%d)\n",
		    room_info.name, room);
	    continue;
	}
	if (summary->count <= 0 &&
	  room_info.first_message_number < room_info.final_message_number) {
	    printf("Missing %s (%d). . .\n", room_info.name, room);
	    printf("\tChecking alt summary. . . ", room_info.name, room);
	    fflush(stdout);
	    dump_cache();
	    summary = get_alt_summary(room);
	    if (summary->count <= 0) {
		printf(" no help.\n");
		printf("\tChecking dbm. . . ", room_info.name, room);
		fflush(stdout);
		dump_cache();
		summary = get_dbm_summary(room);
		if (summary->count <= 0) {
		    printf(" still no help!\n");
		} else {
		    printf(" Whew!\n");
		    if (!put_summary(room)) {
			fprintf(stderr, "\nError storing summary for %s (%d)\n",
				room_info.name, room);
			continue;
		    }
		}
	    } else {
		printf(" merging %d. . . ", summary->count);
		if (!put_summary(room)) {
		    fprintf(stderr, "\nError storing summary for %s (%d)\n",
			    room_info.name, room);
		    continue;
		}
		printf(" done.\n");
	    }
	}
	dump_cache();
    }
    database_shutdown();
    return 0;
}
