#include "../server/config.h"
#include "../server/server.h"

int max_active_slot;
struct client_struct client[MAX_CLIENTS];

user_entry *old_get_user_entry(uid user);

main(int argc,char *argv[])
{
  int ch;
  user_entry *user_info;
  uid uid, last_uid;
  boolean display_uid = FALSE, display_nick = FALSE, display_mail_only = FALSE;
  char id_string[120];
  char *flag = "< last uid >";
  char *mail_address;

  chdir(MESSAGEBASE);
  database_init();
  while ((ch = getopt(argc, argv, "Nmn")) != EOF)
    switch (ch) {
    case 'N':
      display_nick = !display_nick;
      break;
    case 'm':
      display_mail_only = !display_mail_only;
      break;
    case 'n':
      display_uid = !display_uid;
      break;
    }
  last_uid = get_uid(flag);
  for (uid = 0; uid<=last_uid; uid++) {
    if(!(user_info = old_get_user_entry(uid))) continue;
    mail_address = *user_info->mail_address || display_mail_only ?
      user_info->mail_address : user_info->last_access_source;
    if(!*mail_address) continue;
    if(display_uid) {
      if(display_nick) {
	if(*user_info->nick)
	  printf("%4d %s<%s>", uid, user_info->nick, user_info->id);
	else printf("%4d <%s>", uid, user_info->id);
      } else {
	sprintf(id_string,"<%s>", user_info->id);
	printf("%4d %-20s %s\n", uid, id_string, mail_address);
      }
    } else {
      if(display_nick) {
	if(*user_info->nick)
	  printf("%2d %2d:%2.2d:%2.2d %s<%s>\n",
		 user_info->connect_time/60/60/24,
		 user_info->connect_time/60/60%24,
		 user_info->connect_time/60%60,
		 user_info->connect_time%60,
		 user_info->nick,
		 user_info->id);
	else printf("%2d %2d:%2.2d:%2.2d <%s>\n",
		    user_info->connect_time/60/60/24,
		    user_info->connect_time/60/60%24,
		    user_info->connect_time/60%60,
		    user_info->connect_time%60,
		    user_info->id);
      } else {
	sprintf(id_string,"<%s> (%d)", user_info->id, uid);
	printf("%2d %2d:%2.2d:%2.2d %-20s %s\n",
	       user_info->connect_time/60/60/24,
	       user_info->connect_time/60/60%24,
	       user_info->connect_time/60%60,
	       user_info->connect_time%60,
	       id_string,
	       mail_address);
      }
    }
  }
  database_shutdown();
}
