#include "server.h"

void server_groupchangeclass(int i)
{
  char id[ID_SIZE];
  char group[GROUP_SIZE];
  class_t class;
  int j;
  user_entry user_info;
  group_info *group_info;
  bb_uid uid;
  bb_gid gid;

  read_socket_s(client[i].socket, group, sizeof(group));
  read_socket_s(client[i].socket, id, sizeof(id));
  read_socket_int(client[i].socket, (int *) &class);
  
  if((gid = get_gid(group))==-1)
    SERVER_ERROR("no such group");
  if((uid = get_uid(id))==-1)
    SERVER_ERROR("no such user");
  if(!(group_info = get_group_info(i, gid)))
    SERVER_ERROR("error accessing group/user information");
  if(!MODERATOR_ACCESS(group_info->class) && !client[i].owner)
    SERVER_ERROR("permission denied");
  if(!get_user_entry(&user_info, uid))
    SERVER_ERROR("error accessing user information");
  user_info.group_class[gid] = class;
  if(!put_user_entry(uid, &user_info))
    SERVER_ERROR("error storing user information");
  if(class == no_class && !DAEMON(uid)) {
    group_entry group_info;

    if(!get_group_entry(&group_info, gid))
      SERVER_ERROR("group database error");
    class = group_info.default_class;
  }
  for(j=0; j <= max_active_slot; j++)
    if(client[j].signed_on && client[j].uid == uid)
      client[j].group_class[gid] = class;
  write_socket_code(client[i].socket, SERVER_ACK);
}
