#include "../lib/rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/server/whois.c 178 2004-05-05 06:09:03Z kc $")

#include "server.h"

void server_whois(int i)
{
  char id[ID_SIZE];
  bb_uid uid;
  DbUser userinfo;
  int slot;

  read_socket_s(Client[i].socket, id, sizeof(id));

  if(!*id) {
    uid = Client[i].uid;
  } else {
    uid = get_uid(id);
  }
  if(!get_db_user(&userinfo, uid))
    SERVER_ERROR("no such user");
  for(slot = 0; slot <= Max_active_slot; slot++)
    if(Client[slot].signed_on && Client[slot].uid == uid) {
      userinfo.connect_time += Now - Client[slot].signon_time;
      userinfo.posts += Client[slot].posts;
    }
  write_socket_code(Client[i].socket, SERVER_ACK);
  write_socket_string(Client[i].socket, userinfo.id);
  write_socket_string(Client[i].socket, userinfo.nick);
  write_socket_string(Client[i].socket, userinfo.last_access_source);
  write_socket_string(Client[i].socket, userinfo.mail_address);
  write_socket_int(Client[i].socket, userinfo.last_access_time);
  if(Client[i].uid == uid || OPERATOR(Client[i].uid)) {
    write_socket_int(Client[i].socket, userinfo.uses);
    write_socket_int(Client[i].socket, userinfo.posts);
    write_socket_int(Client[i].socket, userinfo.connect_time);
  } else {
    write_socket_int(Client[i].socket, 0);
    write_socket_int(Client[i].socket, 0);
    write_socket_int(Client[i].socket, 0);
  }
}
